---
title: begin
slug: Web/SVG/Attribute/begin
tags:
  - NeedsCompatTable
  - SVG
  - SVG Attribute
---
<div>{{SVGRef}}</div>

<p>The <strong><code>begin</code></strong> attribute defines when an animation should begin or when an element should be discarded.</p>

<p>The attribute value is a semicolon separated list of values. The interpretation of a list of start times is detailed in the SMIL specification in <a class="external" href="http://www.w3.org/TR/2001/REC-smil-animation-20010904/#Timing-EvaluationOfBeginEndTimeLists">"Evaluation of begin and end time lists"</a>. Each individual value can be one of the following : <code>&lt;offset-value&gt;</code>, <code>&lt;syncbase-value&gt;</code>, <code>&lt;event-value&gt;</code>, <code>&lt;repeat-value&gt;</code>, <code>&lt;accessKey-value&gt;</code>, <code>&lt;wallclock-sync-value&gt;</code> or the keyword <code>indefinite</code>.</p>

<p>Six elements are using this attribute: {{SVGElement("animate")}}, {{SVGElement("animateColor")}}, {{SVGElement("animateMotion")}}, {{SVGElement("animateTransform")}}, {{SVGElement("discard")}}, and {{SVGElement("set")}}</p>

<h2 id="animate_animateColor_animateMotion_animateTransform_set">animate, animateColor, animateMotion, animateTransform, set</h2>

<p>For {{SVGElement("animate")}}, {{SVGElement("animateColor")}}, {{SVGElement("animateMotion")}}, {{SVGElement("animateTransform")}}, and {{SVGElement("set")}}, <code>begin</code> defines when the element should begin, i.e. become active.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>&lt;begin-value-list&gt;</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>0s</code></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>No</td>
  </tr>
 </tbody>
</table>

<p>The <code>&lt;begin-value-list&gt;</code> is a semicolon-separated list of values. Each value can be one of the following:</p>

<dl>
 <dt><code>&lt;offset-value&gt;</code></dt>
 <dd>This value defines a <a href="/en-US/docs/Web/SVG/Content_type#Clock-value">clock-value</a> that represents a point in time relative to the beginning of the SVG document (usually the {{event("load")}} or {{event("DOMContentLoaded")}} event). Negative values are valid.</dd>
 <dt><code>&lt;syncbase-value&gt;</code></dt>
 <dd>This value defines a <em>syncbase</em> and an optional offset from that <em>syncbase</em>. The element's animation start time is defined relative to the begin or active end of another animation.</dd>
 <dd>A valid syncbase-value consists of an ID reference to another animation element followed by a dot and either <code>begin</code> or <code>end</code> to identify whether to synchronize with the beginning or active end of the referenced animation element. An optional offset value as defined in <code>&lt;offset-value&gt;</code> can be appended.</dd>
 <dt><code>&lt;event-value&gt;</code></dt>
 <dd>This value defines an event and an optional offset that determines the time at which the element's animation should begin. The animation start time is defined relative to the time that the specified event is fired.</dd>
 <dd>A valid event-value consists of an element ID followed by a dot and one of the supported events for that element. All valid events (not necessarily supported by all elements) are defined by the DOM and HTML specifications. Those are: {{event("focus")}}, {{event("blur")}}, {{event("focusin")}}, {{event("focusout")}}, {{event("activate")}}, {{event("auxclick")}}, {{event("click")}}, {{event("dblclick")}}, {{event("mousedown")}}, {{event("mouseenter")}}, {{event("mouseleave")}}, {{event("mousemove")}}, {{event("mouseout")}}, {{event("mouseover")}}, {{event("mouseup")}}, {{event("wheel")}}, {{event("beforeinput")}}, {{event("input")}}, {{event("keydown")}}, {{event("keyup")}}, {{event("compositionstart")}}, {{event("compositionupdate")}}, {{event("compositionend")}}, {{event("load")}}, {{event("unload")}}, {{event("abort")}}, {{event("error")}}, {{event("select")}}, {{event("resize")}}, {{event("scroll")}}, {{event("beginEvent")}}, {{event("endEvent")}}, and {{event("repeatEvent")}}. An optional offset value as defined in <code>&lt;offset-value&gt;</code> can be appended.</dd>
 <dt><code>&lt;repeat-value&gt;</code></dt>
 <dd>This value defines a qualified repeat event. The element animation start time is defined relative to the time that the repeat event is raised with the specified iteration value.</dd>
 <dd>A valid repeat value consists of an element ID followed by a dot and the function <code>repeat()</code> with an integer value specifying the number of repetitions as parameter. An optional offset value as defined in <code>&lt;offset-value&gt;</code> can be appended.</dd>
 <dt><code>&lt;accessKey-value&gt;</code></dt>
 <dd>This value defines an access key that should trigger the animation. The element animation will begin when the user presses the specified key.</dd>
 <dd>A valid accessKey-value consists of the function <code>accessKey()</code> with the character to be input as parameter. An optional offset value as defined in <code>&lt;offset-value&gt;</code> can be appended.</dd>
 <dt><code>&lt;wallclock-sync-value&gt;</code></dt>
 <dd>This value defines the animation start time as a real-world clock time.</dd>
 <dd>A valid wallclock-sync-value consists of the function <code>wallclock()</code> with a time value as parameter. The time syntax is based upon the syntax defined in <a href="https://www.iso.org/iso-8601-date-and-time-format.html">ISO 8601</a>.</dd>
 <dt><code>indefinite</code></dt>
 <dd>The begin of the animation will be determined by a <code>beginElement()</code> method call or a hyperlink targeted to the element.</dd>
</dl>

<h2 id="discard">discard</h2>

<p>For {{SVGElement("discard")}}, <code>begin</code> defines when the target element will be discarded.</p>

<p>The <code>&lt;discard&gt;</code> element has an implicit simple duration of <code>indefinite</code>. As soon as the element's active duration starts, the element identified by the {{SVGAttr("href")}} attribute is discarded. The behavior is the same as if {{domxref("Node.removeChild()")}} were called on the parent of the target element with the target element as parameter.</p>

<p>After removal of the target element, the <code>&lt;discard&gt;</code> element is no longer useful, therefore it is also discarded after the target element's removal. If the <code>href</code> attribute has an invalid URL reference (e.g. the target element did not exist), the <code>&lt;discard&gt;</code> element itself is still removed after the activation.</p>

<p>Seeking backwards in the timeline doesn't re-insert the discarded elements. So, authors are encouraged to set the {{SVGAttr("playbackorder")}} attribute to <code>forwardonly</code> when using the <code>&lt;discard&gt;</code> element.</p>

<p>The <code>&lt;discard&gt;</code> element itself can be discarded prior to its activation, in which case it will never trigger the removal of its own target element.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>&lt;begin-value-list&gt;</code></td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><code>0s</code></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>No</td>
  </tr>
 </tbody>
</table>

<p>The definition of <code>&lt;begin-value-list&gt;</code> is the <a href="#animate_animateColor_animateMotion_animateTransform_set">same as for the other animation elements</a>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Offset_example">Offset example</h3>

<pre class="brush: html">&lt;svg width="120" height="120"  viewBox="0 0 120 120"
     xmlns="http://www.w3.org/2000/svg" version="1.1"&gt;

    &lt;!-- animated rectangles --&gt;
    &lt;rect x="10" y="35" height="15" width="0"&gt;
        &lt;animate attributeType="XML" attributeName="width" to="100"
                 begin="0s" dur="8s"
                 fill="freeze" /&gt;
    &lt;/rect&gt;

    &lt;rect x="35" y="60" height="15" width="0"&gt;
        &lt;animate attributeType="XML" attributeName="width" to="75"
                 begin="2s" dur="6s"
                 fill="freeze" /&gt;
    &lt;/rect&gt;

    &lt;rect x="60" y="85" height="15" width="0"&gt;
        &lt;animate attributeType="XML" attributeName="width" to="50"
                 begin="4s" dur="4s"
                 fill="freeze" /&gt;
    &lt;/rect&gt;

    &lt;!-- grid --&gt;
    &lt;text x="10" y="20" text-anchor="middle"&gt;0s&lt;/text&gt;
    &lt;line x1="10" y1="25" x2="10" y2="105" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="35" y="20" text-anchor="middle"&gt;2s&lt;/text&gt;
    &lt;line x1="35" y1="25" x2="35" y2="105" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="60" y="20" text-anchor="middle"&gt;4s&lt;/text&gt;
    &lt;line x1="60" y1="25" x2="60" y2="105" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="85" y="20" text-anchor="middle"&gt;6s&lt;/text&gt;
    &lt;line x1="85" y1="25" x2="85" y2="105" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="110" y="20" text-anchor="middle"&gt;8s&lt;/text&gt;
    &lt;line x1="110" y1="25" x2="110" y2="105" stroke="grey" stroke-width=".5" /&gt;

    &lt;line x1="10" y1="30" x2="110" y2="30" stroke="grey" stroke-width=".5" /&gt;
    &lt;line x1="10" y1="105" x2="110" y2="105" stroke="grey" stroke-width=".5" /&gt;
&lt;/svg&gt;
</pre>

<p>{{EmbedLiveSample('Offset_example', '100%', 130)}}</p>

<p><a href="https://mdn.mozillademos.org/files/3290/begin-1-offset.svg">begin-1-offset.svg</a></p>

<h3 id="Syncbase_example">Syncbase example</h3>

<pre class="brush: html">&lt;svg width="120" height="120"  viewBox="0 0 120 120"
     xmlns="http://www.w3.org/2000/svg" version="1.1"
     xmlns:xlink="http://www.w3.org/1999/xlink"&gt;

    &lt;!-- animated rectangles --&gt;
    &lt;rect x="10" y="35" height="15" width="0"&gt;
        &lt;animate attributeType="XML" attributeName="width" to="50"
                 id="first" begin="0s;third.end" dur="4s" /&gt;
    &lt;/rect&gt;

    &lt;rect x="60" y="60" height="15" width="0"&gt;
        &lt;animate attributeType="XML" attributeName="width" to="25"
                 id="second" begin="first.end" dur="2s" /&gt;
    &lt;/rect&gt;

    &lt;rect x="85" y="85" height="15" width="0"&gt;
        &lt;animate attributeType="XML" attributeName="width" to="25"
                 id="third" begin="second.end" dur="2s" /&gt;
    &lt;/rect&gt;

    &lt;!-- grid --&gt;
    &lt;text x="10" y="20" text-anchor="middle"&gt;0s&lt;/text&gt;
    &lt;line x1="10" y1="25" x2="10" y2="105" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="35" y="20" text-anchor="middle"&gt;2s&lt;/text&gt;
    &lt;line x1="35" y1="25" x2="35" y2="105" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="60" y="20" text-anchor="middle"&gt;4s&lt;/text&gt;
    &lt;line x1="60" y1="25" x2="60" y2="105" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="85" y="20" text-anchor="middle"&gt;6s&lt;/text&gt;
    &lt;line x1="85" y1="25" x2="85" y2="105" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="110" y="20" text-anchor="middle"&gt;8s&lt;/text&gt;
    &lt;line x1="110" y1="25" x2="110" y2="105" stroke="grey" stroke-width=".5" /&gt;

    &lt;line x1="10" y1="30" x2="110" y2="30" stroke="grey" stroke-width=".5" /&gt;
    &lt;line x1="10" y1="105" x2="110" y2="105" stroke="grey" stroke-width=".5" /&gt;
&lt;/svg&gt;
</pre>

<p>{{EmbedLiveSample('Syncbase_example', '100%', 130)}}</p>

<p><a href="https://developer.mozilla.org/files/3291/begin-2-syncbase.svg">begin-2-syncbase.svg</a></p>

<h3 id="Event_example">Event example</h3>

<pre class="brush: html">&lt;svg width="120" height="120"  viewBox="0 0 120 120"
     xmlns="http://www.w3.org/2000/svg" version="1.1"
     xmlns:xlink="http://www.w3.org/1999/xlink"&gt;

    &lt;!-- animated rectangle --&gt;
    &lt;rect x="10" y="35" height="15" width="0"&gt;
        &lt;animate attributeType="XML" attributeName="width" from="0" to="100"
                 begin="startButton.click" dur="8s"
                 fill="freeze" /&gt;
    &lt;/rect&gt;

    &lt;!-- trigger --&gt;
    &lt;rect id="startButton" style="cursor:pointer;"
          x="19.5" y="62.5" rx="5" height="25" width="80"
          fill="#EFEFEF" stroke="black" stroke-width="1" /&gt;

    &lt;text x="60" y="80" text-anchor="middle"
          style="pointer-events:none;"&gt;Click me.&lt;/text&gt;

    &lt;!-- grid --&gt;
    &lt;text x="10" y="20" text-anchor="middle"&gt;0s&lt;/text&gt;
    &lt;line x1="10" y1="25" x2="10" y2="55" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="35" y="20" text-anchor="middle"&gt;2s&lt;/text&gt;
    &lt;line x1="35" y1="25" x2="35" y2="55" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="60" y="20" text-anchor="middle"&gt;4s&lt;/text&gt;
    &lt;line x1="60" y1="25" x2="60" y2="55" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="85" y="20" text-anchor="middle"&gt;6s&lt;/text&gt;
    &lt;line x1="85" y1="25" x2="85" y2="55" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="110" y="20" text-anchor="middle"&gt;8s&lt;/text&gt;
    &lt;line x1="110" y1="25" x2="110" y2="55" stroke="grey" stroke-width=".5" /&gt;

    &lt;line x1="10" y1="30" x2="110" y2="30" stroke="grey" stroke-width=".5" /&gt;
    &lt;line x1="10" y1="55" x2="110" y2="55" stroke="grey" stroke-width=".5" /&gt;
&lt;/svg&gt;
</pre>

<p>{{EmbedLiveSample('Event_example', '100%', 130)}}</p>

<p><a href="https://developer.mozilla.org/files/3292/begin-3-event.svg">begin-3-event.svg</a></p>

<h3 id="Repeat_example">Repeat example</h3>

<pre class="brush: html">&lt;svg width="120" height="120"  viewBox="0 0 120 120"
     xmlns="http://www.w3.org/2000/svg" version="1.1"
     xmlns:xlink="http://www.w3.org/1999/xlink"&gt;

    &lt;!-- animated rectangle --&gt;
    &lt;rect x="10" y="35" height="15" width="0"&gt;
        &lt;animate attributeType="XML" attributeName="width" from="0" to="100"
                 id="myLoop" begin="0s;myLoop.end" dur="4s"
                 repeatCount="3" /&gt;

        &lt;set attributeType="CSS" attributeName="fill" to="green"
             begin="myLoop.begin" /&gt;

        &lt;set attributeType="CSS" attributeName="fill" to="gold"
             begin="myLoop.repeat(1)" /&gt;

        &lt;set attributeType="CSS" attributeName="fill" to="red"
             begin="myLoop.repeat(2)" /&gt;
    &lt;/rect&gt;

    &lt;!-- grid --&gt;
    &lt;text x="10" y="20" text-anchor="middle"&gt;0s&lt;/text&gt;
    &lt;line x1="10" y1="25" x2="10" y2="55" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="35" y="20" text-anchor="middle"&gt;1s&lt;/text&gt;
    &lt;line x1="35" y1="25" x2="35" y2="55" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="60" y="20" text-anchor="middle"&gt;2s&lt;/text&gt;
    &lt;line x1="60" y1="25" x2="60" y2="55" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="85" y="20" text-anchor="middle"&gt;3s&lt;/text&gt;
    &lt;line x1="85" y1="25" x2="85" y2="55" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="110" y="20" text-anchor="middle"&gt;4s&lt;/text&gt;
    &lt;line x1="110" y1="25" x2="110" y2="55" stroke="grey" stroke-width=".5" /&gt;

    &lt;line x1="10" y1="30" x2="110" y2="30" stroke="grey" stroke-width=".5" /&gt;
    &lt;line x1="10" y1="55" x2="110" y2="55" stroke="grey" stroke-width=".5" /&gt;
&lt;/svg&gt;
</pre>

<p>{{EmbedLiveSample('Repeat_example', '100%', 130)}}</p>

<p><a href="https://developer.mozilla.org/files/3293/begin-4-repeat.svg">begin-4-repeat.svg</a></p>

<h3 id="Accesskey_example">Accesskey example</h3>

<pre class="brush: html">&lt;svg width="120" height="120"  viewBox="0 0 120 120"
     xmlns="http://www.w3.org/2000/svg" version="1.1"
     xmlns:xlink="http://www.w3.org/1999/xlink"&gt;

    &lt;!-- animated rectangles --&gt;
    &lt;rect x="10" y="35" height="15" width="0"&gt;
        &lt;animate attributeType="XML" attributeName="width" from="0" to="100"
                 begin="accessKey(s)" dur="8s"
                 fill="freeze" /&gt;
    &lt;/rect&gt;

    &lt;!-- trigger --&gt;
    &lt;text x="60" y="80" text-anchor="middle"
          style="pointer-events:none;"&gt;Hit the "s" key&lt;/text&gt;

    &lt;!-- grid --&gt;
    &lt;text x="10" y="20" text-anchor="middle"&gt;0s&lt;/text&gt;
    &lt;line x1="10" y1="25" x2="10" y2="55" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="35" y="20" text-anchor="middle"&gt;2s&lt;/text&gt;
    &lt;line x1="35" y1="25" x2="35" y2="55" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="60" y="20" text-anchor="middle"&gt;4s&lt;/text&gt;
    &lt;line x1="60" y1="25" x2="60" y2="55" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="85" y="20" text-anchor="middle"&gt;6s&lt;/text&gt;
    &lt;line x1="85" y1="25" x2="85" y2="55" stroke="grey" stroke-width=".5" /&gt;
    &lt;text x="110" y="20" text-anchor="middle"&gt;8s&lt;/text&gt;
    &lt;line x1="110" y1="25" x2="110" y2="55" stroke="grey" stroke-width=".5" /&gt;

    &lt;line x1="10" y1="30" x2="110" y2="30" stroke="grey" stroke-width=".5" /&gt;
    &lt;line x1="10" y1="55" x2="110" y2="55" stroke="grey" stroke-width=".5" /&gt;
&lt;/svg&gt;
</pre>

<p>{{EmbedLiveSample('Accesskey_example', '100%', 130)}}</p>

<p><em>This example is embed in an iFrame. If you want to activate the key events, you have to click on it first.</em></p>

<p><a href="https://developer.mozilla.org/files/3294/begin-5-accesskey.svg">begin-5-accesskey.svg</a></p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("SVG Animations 2", "#DiscardElementBeginAttribute", "begin for &lt;discard&gt;")}}</td>
   <td>{{Spec2("SVG Animations 2")}}</td>
   <td>Adds the definition for the {{SVGElement("discard")}} element.</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG Animations 2", "#BeginAttribute", "begin")}}</td>
   <td>{{Spec2("SVG Animations 2")}}</td>
   <td>Refers to the specifications in DOM UI events and HTML for the <code>&lt;event-value&gt;</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "animate.html#BeginAttribute", "begin")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>
